if service.getEditText() then
  dictAr()
 else
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then
          if text:lower() == "توقف" then
            this.postSpeak(200, "تم إيقافُ البحث.")
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "المساعد السريع" then
            this.postSpeak(200, "اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                quickAssist()
               else
                handler.postDelayed(checkSpeakingStatus, 1000)
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500)
            return
           elseif text == "الاملاء" then
            dictAr()
            return


           elseif text == "حذف العناصر المحدده" then
            service.click({{ "#bottom_menu_delete$0","#check_permanently_delete>10$0","#button1>10",}})
            return
           elseif text == "خصائص العنصر الحالي" then
            if service.click({{"%pression prolongée$100", "#bottom_menu_more>10$100","Propriétés>10",}})
             elseif service.click({{ "#bottom_menu_more$100","Propriétés>10",}})
            end
            return
           elseif text == "مشاركه العنصر الحالي" then
            if service.click({{"%pression prolongée$100", "#bottom_menu_more>10$100","Partager>10",}})
             elseif service.click({{ "#bottom_menu_more>10$100","Partager>10",}})
            end
            return

           elseif text == "اعاده تسميه العنصر الحالي" then
            if service.click({{"%pression prolongée$100", "#bottom_menu_rename>10",}})
             elseif service.click({{"#bottom_menu_rename",}})
            end
            return
           elseif text == "نسخ العنصر الحالي" then
            if service.click({{"%pression prolongée$100", "#bottom_menu_copy>10",}})
             elseif service.click({{"#bottom_menu_copy",}})
            end
            return
           elseif text == "نقل العنصر الحالي" then
            if service.click({{"%pression prolongée$100", "#bottom_menu_cut>10",}})
             elseif service.click({{"#bottom_menu_cut",}})
            end
            return
           elseif text == "حذف العنصر الحالي" or text == "حذف العناصر المحدده" then
            if service.click({{"%pression prolongée$100", "#bottom_menu_delete>10$0","#check_permanently_delete>10$0","#button1>10",}})
             elseif service.click({{ "#bottom_menu_delete$0","#check_permanently_delete>10$0","#button1>10",}})
            end
            return
           elseif text == "حذف جميع العناصر" then
            service.click({{"#menu_select_all$100", "#bottom_menu_delete>10$0","#check_permanently_delete>10$0","#button1>10",}})
            return

           elseif text == "ملف جديد" then
            service.click({{"Plus d'options$100","Nouveau$300","Fichier",}})
            task(1800, function()
              dictAr()
            end)
            return
           elseif text == "مجلد جديد" then
            service.click({{"Plus d'options$100","Nouveau$300","Dossier",}})
            task(1800, function()
              dictAr()
            end)
            return


           elseif text == "البحث في المجلد الحالي" then
            service.click({{"Plus d'options$300","Rechercher$300","Tous les sous-dossiers",}})
            task(1800, function()
              dictAr()
            end)
            return
           elseif text == "البحث في جميع المجلدات الفرعيه" then
            service.click({{"Plus d'options$300","Rechercher$300","Dossier actuel",}})
            task(1800, function()
              dictAr()
            end)
            return


                      elseif text:lower() == "المساعده العامه" then
            dofile(dir.. "help.lua")
            return
           elseif text:lower() == "المساعده" then

            local helpText = [[
توقف  
تحديث المفتاح
المساعد السريع
الإملاء
حذف العناصر المحددة  
خصائص العنصر الحالي  
مشاركة العنصر الحالي  
إعادة تسمية العنصر الحالي  
نسخ العنصر الحالي  
نقل العنصر الحالي  
حذف العنصر الحالي  
حذف جميع العناصر  
ملف جديد  
مجلد جديد  
البحث في المجلد الحالي  
البحث في جميع المجلدات الفرعية  
المساعدة
المساعَدة العامة.
           ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
            return
           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,

      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  service.speak("CX. ")
  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      startVoiceRecognition(activity)
     else
      handler.postDelayed(checkSpeakingStatus, 500)
    end
  end
  handler.postDelayed(checkSpeakingStatus, 500)
end